# I18n

Everything for i18n is located at `frontend/i18n/`

- `frontend/i18n/ids.ts` defines an enum of possible phrases where we got a translation for (ids)
- `frontend/i18n/en_en.ts` defines an object where the props are the enum values and the values of the object are the translation


## Usage

In `frontend/i18n/translationHelper.ts` there is a function `translate` that can be used for *translation*

In react just use the `{}` and call the `translate` function like

```ts
render(): JSX.Element {
    return (
      <div>
        <Button
          content={translate(TranslateIds.cancel)}
        />
      </div>
    )
  }
```

The enum ensures that you can only use known ids


## Todo

This can be done a lot better! e.g.

- there is currently no check if we used all enum values (ids)
- only one language is supported
	- even the translate function only takes the id and not the language
