# Useful css

some useful css rules, fh, hoverable, ...

In `frontend/src/styles/common.styl` or `frontend/src/styles/behaviours.styl`

## Visual

- `fh` for 100% height
- `mar-right` use this for right margin spacing
	- we use normally right margin for spacing
- `mar-left` used for left margin (try to avoid this and use `mar-right`)
- `mar-left-half` half of `mar-left`
- `mar-null` zero margin
- `div-disabled` to disable interaction with an element

## Colors

- `error-colored` error colored foreground
- `error-bg-colored` error colored background
- `blue-colored` blue colored foreground
- `ok-colored` ok colored fg
- `ok-bg-colored` ok colored bg
- `accent-colored` accent colored fg
- `link-colored` link colored fg

and of course the color variables in `frontend/src/styles/common.styl` (at the top)

## Behaviors

- `clickable` if the item is clickable
- `hoverable` if the item is hoverable
- `hoverable-disabled` disabled hoverable
- `toggled-colored` if something can be toggled (e.g. an icon) this sets the toggled foreground color
- `clickable-toggled` if the item is clickable and currently toggled

## For components

### Tables

For tables use the css class `material-table` e.g.

```html
<Table padded striped singleLine className="material-table">
</Table>
```

### Inputs

There is an already styled component in `frontend/src/components/material/materialInput.tsx`

### Search input

There is an already styled component in `frontend/src/components/material/materialSearchInput.tsx`

### Select

There is an already styled component in `frontend/src/components/material/materialSelectWrapper.tsx`

### Text area

There is an already styled component in `frontend/src/components/material/materialTextArea.tsx

### Date (and time) input

There is an already styled component in `frontend/src/components/material/materialDatetimeInput.tsx`
