# Dependency: Dotnet SDK 1.1.11

This guide is tested on Debian 9 (Stretch). You can install Dotnet Version 1.1.11 differently, this is just our way. (Please note the [official Microsoft download site](https://dotnet.microsoft.com/download/dotnet-core/1.1)).

## Subdependencies

If you choose to install Dotnet the same way we chose, you need some packages.

```bash
apt install libunwind-dev
apt isntall libcurl3 
```

## Download the Dotnet SDK 1.1.11

Currently, Dotnet Version 1.1.11 is used. You can obtain a binary blob [here](https://github.com/dotnet/core/blob/master/release-notes/1.1/1.1.11/1.1.11-download.md). (Download the SDK, not the Runtime Environment.)

## Install Dotnet SDK 1.1.11

Run as root:
```bash
mkdir -p /opt/dotnet
tar -zxf [dotnet].tar.gz -C /opt/dotnet
```
Dotnet is installed to `/opt/dotnet/`.
If there is now a non-empty directory `/opt/dotnet/` it worked.

```bash
cd /opt/dotnet
# create symbolic link from /usr/local/bin/dotnet -> /opt/dotnet/dotnet
sudo ln -s /opt/dotnet/dotnet /usr/local/bin/dotnet
```
Then it's linked to `/usr/local/bin/dotnet/`. This means it can be called as `dotnet`.
Run `which dotnet`. It should answer `/user/local/bin/dotnet`. That's where you linked it to.

Try running `dotnet --version`. This will return `1.1.12`.
