# How to prepare the Database for the main backend (ClientServer) – yapexDb

## Prerequisites

* Having [PostgreSQL](https://gitlab.informatik.uni-halle.de/Syndrom/Docs/-/blob/extended-guides/installation/dependencies/postgresql.md) installed

## Creating and configuring yapexDb

When postgres is installed, a linux user called `postgres` is created. (It's usually not visible at the login screen but it's still there.) When configuring the Postgresql database the commands have to be run by that user.

That can be done by `sudo -u postgres <the command>` or with `su - postgres` once in the beginning. (Leaving that user can be done by `exit`.)

1. Create a PostgreSQL User

PostgreSQL is a DBMS (Database Management System). It runs as a server on a different port on your computer.

Run `createuser yapex --pwprompt`. (This create a database-user called `yapex`.)

You have to remember your password! You will need it later on!


2. Creating the Databse

```bash
createdb yapexDb
```

3. Granting the rights to that user

First on, you enter the psql console with `psql postgres`. Now the prompt should be `psql=#`.

In that console type
```bash
grant all privileges on database "yapexDb" to yapex ;
```
(in production you might give only insert, update, delete rights... but then you need another user to do database migrations!)

Close the console via `\q`.

## PostgreSQL settings

In the file `/etc/postgresql/[version]/main/pg_hba.conf` change
```bash
local   all             all                                     peer
```
to
```bash
local   all             all                                     md5
```

## If everything gone wrong

You can delete the Database `yapexDb` using `drop database "yapexDb" ;`. Afterwards, recreate it and grant the rights.
