# On the TestServer

What is a Test Server? It's a server (or VM, or Docker) made to run Yapex for the purpose of testing (wether the latest changes broke anything).

What means 'running Yapex' in this context? There will usually be services to run an instance of each

* the ClientServer (where the build files from the frontend are within)
* the TestRunner (this runs programs written by the Users, within Yapex, and gives inputs from testcases (those written by users, within Yapex) and compares the outputs from those programs with the 'correct' outputs, given by the testcases

## For the dev

You can connect to that server with `ssh username@testserver`. (Note: You must have an SSH-key for doing so, and the local admin must have allowed login for that specific user with that specific SSH-key.)

It worked if the command line prompt changed.

Any Yapex-related code is usually in `/opt/yapex/`, for each the ClientServer and a TestRunner (either `LinuxSafeTestRunner` or `TestServer` – yes that's a confusing name) their own directory.

You should have writing access to either of these, although you will likely not be (and shouldn't be) root. You can override them with new versions of the code, but save what's already there! (Escpecially the system salt.)

You can copy new code to the server with [`scp`](https://www.ssh.com/ssh/scp/). You will most likely have to change various passwords (for database access, for instance) and the system salt. Any of these should be provided by the admin.

## Trouble Shooting

This won't cover anything that could happen. But it's a good place to begin with.

1. Do the services run? Check their status.
2. Check the system log. (In Linux it's `/var/log/syslog/`. You read the last N lines with `tail -N /var/log/syslog`)
3. Compare the settings of whatever component failed to any settings file available.

It's always helpfull to restart the TestServer (`sudo reboot`) because when starting each component it checks itself so you will most likely see most errors there. (You have to reconnect to the server after doing so.)

## Visiting Test-Yapex in the Browser

You have to know either Ip address or url of the testserver (the one you connected to with ssh) and on which port the ClientServer runs. (Standard is 8002)

This resolves to the address `ip_or_url:port`. (Yes, that's what has to be typed into the Url-bar of the browser.) If you get a blank page you should try again with `https://`.
